require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_MTD_MAP_H__)) {
    eval 'sub __LINUX_MTD_MAP_H__ () {1;}' unless defined(&__LINUX_MTD_MAP_H__);
    require 'linux/config.ph';
    require 'linux/types.ph';
    require 'linux/list.ph';
    require 'linux/string.ph';
    require 'linux/mtd/compatmac.ph';
    require 'asm/unaligned.ph';
    require 'asm/system.ph';
    require 'asm/io.ph';
    if(defined(&CONFIG_MTD_MAP_BANK_WIDTH_1)) {
	eval 'sub map_bankwidth {
	    my($map) = @_;
    	    eval q(1);
	}' unless defined(&map_bankwidth);
	eval 'sub map_bankwidth_is_1 {
	    my($map) = @_;
    	    eval q(( &map_bankwidth($map) == 1));
	}' unless defined(&map_bankwidth_is_1);
	eval 'sub map_bankwidth_is_large {
	    my($map) = @_;
    	    eval q((0));
	}' unless defined(&map_bankwidth_is_large);
	eval 'sub map_words {
	    my($map) = @_;
    	    eval q((1));
	}' unless defined(&map_words);
	eval 'sub MAX_MAP_BANKWIDTH () {1;}' unless defined(&MAX_MAP_BANKWIDTH);
    } else {
	eval 'sub map_bankwidth_is_1 {
	    my($map) = @_;
    	    eval q((0));
	}' unless defined(&map_bankwidth_is_1);
    }
    if(defined(&CONFIG_MTD_MAP_BANK_WIDTH_2)) {
	if(defined(&map_bankwidth)) {
	    undef(&map_bankwidth) if defined(&map_bankwidth);
	    eval 'sub map_bankwidth {
	        my($map) = @_;
    		eval q((($map)-> &bankwidth));
	    }' unless defined(&map_bankwidth);
	} else {
	    eval 'sub map_bankwidth {
	        my($map) = @_;
    		eval q(2);
	    }' unless defined(&map_bankwidth);
	    eval 'sub map_bankwidth_is_large {
	        my($map) = @_;
    		eval q((0));
	    }' unless defined(&map_bankwidth_is_large);
	    eval 'sub map_words {
	        my($map) = @_;
    		eval q((1));
	    }' unless defined(&map_words);
	}
	eval 'sub map_bankwidth_is_2 {
	    my($map) = @_;
    	    eval q(( &map_bankwidth($map) == 2));
	}' unless defined(&map_bankwidth_is_2);
	undef(&MAX_MAP_BANKWIDTH) if defined(&MAX_MAP_BANKWIDTH);
	eval 'sub MAX_MAP_BANKWIDTH () {2;}' unless defined(&MAX_MAP_BANKWIDTH);
    } else {
	eval 'sub map_bankwidth_is_2 {
	    my($map) = @_;
    	    eval q((0));
	}' unless defined(&map_bankwidth_is_2);
    }
    if(defined(&CONFIG_MTD_MAP_BANK_WIDTH_4)) {
	if(defined(&map_bankwidth)) {
	    undef(&map_bankwidth) if defined(&map_bankwidth);
	    eval 'sub map_bankwidth {
	        my($map) = @_;
    		eval q((($map)-> &bankwidth));
	    }' unless defined(&map_bankwidth);
	} else {
	    eval 'sub map_bankwidth {
	        my($map) = @_;
    		eval q(4);
	    }' unless defined(&map_bankwidth);
	    eval 'sub map_bankwidth_is_large {
	        my($map) = @_;
    		eval q((0));
	    }' unless defined(&map_bankwidth_is_large);
	    eval 'sub map_words {
	        my($map) = @_;
    		eval q((1));
	    }' unless defined(&map_words);
	}
	eval 'sub map_bankwidth_is_4 {
	    my($map) = @_;
    	    eval q(( &map_bankwidth($map) == 4));
	}' unless defined(&map_bankwidth_is_4);
	undef(&MAX_MAP_BANKWIDTH) if defined(&MAX_MAP_BANKWIDTH);
	eval 'sub MAX_MAP_BANKWIDTH () {4;}' unless defined(&MAX_MAP_BANKWIDTH);
    } else {
	eval 'sub map_bankwidth_is_4 {
	    my($map) = @_;
    	    eval q((0));
	}' unless defined(&map_bankwidth_is_4);
    }
    eval 'sub map_calc_words {
        my($map) = @_;
	    eval q((( &map_bankwidth($map) + ($sizeof{\'unsigned long\'}-1))/ $sizeof{\'unsigned long\'}));
    }' unless defined(&map_calc_words);
    if(defined(&CONFIG_MTD_MAP_BANK_WIDTH_8)) {
	if(defined(&map_bankwidth)) {
	    undef(&map_bankwidth) if defined(&map_bankwidth);
	    eval 'sub map_bankwidth {
	        my($map) = @_;
    		eval q((($map)-> &bankwidth));
	    }' unless defined(&map_bankwidth);
	    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : 0) < 64) {
		undef(&map_bankwidth_is_large) if defined(&map_bankwidth_is_large);
		eval 'sub map_bankwidth_is_large {
		    my($map) = @_;
    		    eval q(( &map_bankwidth($map) >  &BITS_PER_LONG/8));
		}' unless defined(&map_bankwidth_is_large);
		undef(&map_words) if defined(&map_words);
		eval 'sub map_words {
		    my($map) = @_;
    		    eval q( &map_calc_words($map));
		}' unless defined(&map_words);
	    }
	} else {
	    eval 'sub map_bankwidth {
	        my($map) = @_;
    		eval q(8);
	    }' unless defined(&map_bankwidth);
	    eval 'sub map_bankwidth_is_large {
	        my($map) = @_;
    		eval q(( &BITS_PER_LONG < 64));
	    }' unless defined(&map_bankwidth_is_large);
	    eval 'sub map_words {
	        my($map) = @_;
    		eval q( &map_calc_words($map));
	    }' unless defined(&map_words);
	}
	eval 'sub map_bankwidth_is_8 {
	    my($map) = @_;
    	    eval q(( &map_bankwidth($map) == 8));
	}' unless defined(&map_bankwidth_is_8);
	undef(&MAX_MAP_BANKWIDTH) if defined(&MAX_MAP_BANKWIDTH);
	eval 'sub MAX_MAP_BANKWIDTH () {8;}' unless defined(&MAX_MAP_BANKWIDTH);
    } else {
	eval 'sub map_bankwidth_is_8 {
	    my($map) = @_;
    	    eval q((0));
	}' unless defined(&map_bankwidth_is_8);
    }
    if(defined(&CONFIG_MTD_MAP_BANK_WIDTH_16)) {
	if(defined(&map_bankwidth)) {
	    undef(&map_bankwidth) if defined(&map_bankwidth);
	    eval 'sub map_bankwidth {
	        my($map) = @_;
    		eval q((($map)-> &bankwidth));
	    }' unless defined(&map_bankwidth);
	    undef(&map_bankwidth_is_large) if defined(&map_bankwidth_is_large);
	    eval 'sub map_bankwidth_is_large {
	        my($map) = @_;
    		eval q(( &map_bankwidth($map) >  &BITS_PER_LONG/8));
	    }' unless defined(&map_bankwidth_is_large);
	    undef(&map_words) if defined(&map_words);
	    eval 'sub map_words {
	        my($map) = @_;
    		eval q( &map_calc_words($map));
	    }' unless defined(&map_words);
	} else {
	    eval 'sub map_bankwidth {
	        my($map) = @_;
    		eval q(16);
	    }' unless defined(&map_bankwidth);
	    eval 'sub map_bankwidth_is_large {
	        my($map) = @_;
    		eval q((1));
	    }' unless defined(&map_bankwidth_is_large);
	    eval 'sub map_words {
	        my($map) = @_;
    		eval q( &map_calc_words($map));
	    }' unless defined(&map_words);
	}
	eval 'sub map_bankwidth_is_16 {
	    my($map) = @_;
    	    eval q(( &map_bankwidth($map) == 16));
	}' unless defined(&map_bankwidth_is_16);
	undef(&MAX_MAP_BANKWIDTH) if defined(&MAX_MAP_BANKWIDTH);
	eval 'sub MAX_MAP_BANKWIDTH () {16;}' unless defined(&MAX_MAP_BANKWIDTH);
    } else {
	eval 'sub map_bankwidth_is_16 {
	    my($map) = @_;
    	    eval q((0));
	}' unless defined(&map_bankwidth_is_16);
    }
    if(defined(&CONFIG_MTD_MAP_BANK_WIDTH_32)) {
	if(defined(&map_bankwidth)) {
	    undef(&map_bankwidth) if defined(&map_bankwidth);
	    eval 'sub map_bankwidth {
	        my($map) = @_;
    		eval q((($map)-> &bankwidth));
	    }' unless defined(&map_bankwidth);
	    undef(&map_bankwidth_is_large) if defined(&map_bankwidth_is_large);
	    eval 'sub map_bankwidth_is_large {
	        my($map) = @_;
    		eval q(( &map_bankwidth($map) >  &BITS_PER_LONG/8));
	    }' unless defined(&map_bankwidth_is_large);
	    undef(&map_words) if defined(&map_words);
	    eval 'sub map_words {
	        my($map) = @_;
    		eval q( &map_calc_words($map));
	    }' unless defined(&map_words);
	} else {
	    eval 'sub map_bankwidth {
	        my($map) = @_;
    		eval q(32);
	    }' unless defined(&map_bankwidth);
	    eval 'sub map_bankwidth_is_large {
	        my($map) = @_;
    		eval q((1));
	    }' unless defined(&map_bankwidth_is_large);
	    eval 'sub map_words {
	        my($map) = @_;
    		eval q( &map_calc_words($map));
	    }' unless defined(&map_words);
	}
	eval 'sub map_bankwidth_is_32 {
	    my($map) = @_;
    	    eval q(( &map_bankwidth($map) == 32));
	}' unless defined(&map_bankwidth_is_32);
	undef(&MAX_MAP_BANKWIDTH) if defined(&MAX_MAP_BANKWIDTH);
	eval 'sub MAX_MAP_BANKWIDTH () {32;}' unless defined(&MAX_MAP_BANKWIDTH);
    } else {
	eval 'sub map_bankwidth_is_32 {
	    my($map) = @_;
    	    eval q((0));
	}' unless defined(&map_bankwidth_is_32);
    }
    unless(defined(&map_bankwidth)) {
	die("No bus width supported. What's the point?");
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub map_bankwidth_supported {
        my($w) = @_;
	    eval q({  &switch ($w) { 1;  &default: 0; } });
    }' unless defined(&map_bankwidth_supported);
    eval 'sub MAX_MAP_LONGS () {( (( &MAX_MAP_BANKWIDTH*8) +  &BITS_PER_LONG - 1) /  &BITS_PER_LONG );}' unless defined(&MAX_MAP_LONGS);
    eval 'sub NO_XIP () {(-1);}' unless defined(&NO_XIP);
    if(defined(&CONFIG_MTD_COMPLEX_MAPPINGS)) {
    }
    eval 'sub ENABLE_VPP {
        my($map) = @_;
	    eval q( &do {  &if( ($map->{set_vpp}))  ($map->{set_vpp})($map, 1); }  &while(0));
    }' unless defined(&ENABLE_VPP);
    eval 'sub DISABLE_VPP {
        my($map) = @_;
	    eval q( &do {  &if( ($map->{set_vpp}))  ($map->{set_vpp})($map, 0); }  &while(0));
    }' unless defined(&DISABLE_VPP);
    eval 'sub INVALIDATE_CACHED_RANGE {
        my($map, $from, $size) = @_;
	    eval q( &do {  &if( ($map->{inval_cache}))  ($map->{inval_cache})($map, $from, $size); }  &while(0));
    }' unless defined(&INVALIDATE_CACHED_RANGE);
    eval 'sub map_word_equal {
        my($map,$val1,$val2) = @_;
	    eval q({ \'int\'  &i;  &for ( &i=0;  &i< &map_words($map);  &i++) {  &if ( ($val1->{x[&i]}) !=  ($val2->{x[&i]})) 0; } 1; });
    }' unless defined(&map_word_equal);
    eval 'sub map_word_and {
        my($map,$val1,$val2) = @_;
	    eval q({  &map_word  &r; \'int\'  &i;  &for ( &i=0;  &i< &map_words($map);  &i++) {  ($r->{x[&i]}) =  ($val1->{x[&i]}) &  ($val2->{x[&i]}); }  &r; });
    }' unless defined(&map_word_and);
    eval 'sub map_word_clr {
        my($map,$val1,$val2) = @_;
	    eval q({  &map_word  &r; \'int\'  &i;  &for ( &i=0;  &i< &map_words($map);  &i++) {  ($r->{x[&i]}) =  ($val1->{x[&i]}) & ~ ($val2->{x[&i]}); }  &r; });
    }' unless defined(&map_word_clr);
    eval 'sub map_word_or {
        my($map,$val1,$val2) = @_;
	    eval q({  &map_word  &r; \'int\'  &i;  &for ( &i=0;  &i< &map_words($map);  &i++) {  ($r->{x[&i]}) =  ($val1->{x[&i]}) |  ($val2->{x[&i]}); }  &r; });
    }' unless defined(&map_word_or);
    eval 'sub map_word_andequal {
        my($m, $a, $b, $z) = @_;
	    eval q( &map_word_equal($m, $z,  &map_word_and($m, $a, $b)));
    }' unless defined(&map_word_andequal);
    eval 'sub map_word_bitsset {
        my($map,$val1,$val2) = @_;
	    eval q({ \'int\'  &i;  &for ( &i=0;  &i< &map_words($map);  &i++) {  &if ( ($val1->{x[&i]}) &  ($val2->{x[&i]})) 1; } 0; });
    }' unless defined(&map_word_bitsset);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub map_word_load {
        my($map,$ptr) = @_;
	    eval q({  &map_word  &r;  &if ( &map_bankwidth_is_1)  ($r->{x[0]}) = *$ptr;  &else  &if ( &map_bankwidth_is_2($map))  ($r->{x[0]}) =  &get_unaligned(( &uint16_t *)$ptr);  &else  &if ( &map_bankwidth_is_4($map))  ($r->{x[0]}) =  &get_unaligned(( &uint32_t *)$ptr);  &else  &if ( &map_bankwidth_is_large($map))  &memcpy( ($r->{x}), $ptr,  ($map->{bankwidth}));  &r; });
    }' unless defined(&map_word_load);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub map_word_load_partial {
        my($map,$orig,$buf,$start,$len) = @_;
	    eval q({ \'int\'  &i;  &if ( &map_bankwidth_is_large($map)) { \'char\' * &dest = $orig;  &memcpy( &dest+$start, $buf, $len); }  &else {  &for ( &i=$start;  &i < $start+$len;  &i++) { \'int\'  &bitpos;  ($orig->{x[0]}) &= ~(0xff <<  &bitpos);  ($orig->{x[0]}) |= $buf->[ &i-$start] <<  &bitpos; } } $orig; });
    }' unless defined(&map_word_load_partial);
    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : 0) < 64) {
	eval 'sub MAP_FF_LIMIT () {4;}' unless defined(&MAP_FF_LIMIT);
    } else {
	eval 'sub MAP_FF_LIMIT () {8;}' unless defined(&MAP_FF_LIMIT);
    }
    eval 'sub map_word_ff {
        my($map) = @_;
	    eval q({  &map_word  &r; \'int\'  &i;  &if ( &map_bankwidth($map) <  &MAP_FF_LIMIT) { \'int\'  &bw = 8*  &map_bankwidth($map);  ($r->{x[0]}) = (1<<  &bw) - 1; }  &else {  &for ( &i=0;  &i< &map_words($map);  &i++)  ($r->{x[&i]}) = ~0; }  &r; });
    }' unless defined(&map_word_ff);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub inline_map_read {
        my($map,$ofs) = @_;
	    eval q({  &map_word  &r;  &if ( &map_bankwidth_is_1($map))  ($r->{x[0]}) =  &__raw_readb( ($map->{virt}) + $ofs);  &else  &if ( &map_bankwidth_is_2($map))  ($r->{x[0]}) =  &__raw_readw( ($map->{virt}) + $ofs);  &else  &if ( &map_bankwidth_is_4($map))  ($r->{x[0]}) =  &__raw_readl( ($map->{virt}) + $ofs);  &else  &if ( &map_bankwidth_is_large($map))  &memcpy_fromio( ($r->{x}),  ($map->{virt})+$ofs,  ($map->{bankwidth}));  &r; });
    }' unless defined(&inline_map_read);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub inline_map_write {
        my($map,$datum,$ofs) = @_;
	    eval q({  &if ( &map_bankwidth_is_1($map))  &__raw_writeb( ($datum->{x[0]}),  ($map->{virt}) + $ofs);  &else  &if ( &map_bankwidth_is_2($map))  &__raw_writew( ($datum->{x[0]}),  ($map->{virt}) + $ofs);  &else  &if ( &map_bankwidth_is_4($map))  &__raw_writel( ($datum->{x[0]}),  ($map->{virt}) + $ofs);  &else  &if ( &map_bankwidth_is_large($map))  &memcpy_toio( ($map->{virt})+$ofs,  ($datum->{x}),  ($map->{bankwidth}));  &mb(); });
    }' unless defined(&inline_map_write);
    eval 'sub inline_map_copy_from {
        my($map,$to,$from,$len) = @_;
	    eval q({  &if ( ($map->{cached}))  &memcpy($to,  ($map->{cached}) + $from, $len);  &else  &memcpy_fromio($to,  ($map->{virt}) + $from, $len); });
    }' unless defined(&inline_map_copy_from);
    eval 'sub inline_map_copy_to {
        my($map,$to,$from,$len) = @_;
	    eval q({  &memcpy_toio( ($map->{virt}) + $to, $from, $len); });
    }' unless defined(&inline_map_copy_to);
    if(defined(&CONFIG_MTD_COMPLEX_MAPPINGS)) {
	eval 'sub map_read {
	    my($map, $ofs) = @_;
    	    eval q(($map)-> &read($map, $ofs));
	}' unless defined(&map_read);
	eval 'sub map_copy_from {
	    my($map, $to, $from, $len) = @_;
    	    eval q(($map)-> &copy_from($map, $to, $from, $len));
	}' unless defined(&map_copy_from);
	eval 'sub map_write {
	    my($map, $datum, $ofs) = @_;
    	    eval q(($map)-> &write($map, $datum, $ofs));
	}' unless defined(&map_write);
	eval 'sub map_copy_to {
	    my($map, $to, $from, $len) = @_;
    	    eval q(($map)-> &copy_to($map, $to, $from, $len));
	}' unless defined(&map_copy_to);
	eval 'sub map_is_linear {
	    my($map) = @_;
    	    eval q(( ($map->{phys}) !=  &NO_XIP));
	}' unless defined(&map_is_linear);
    } else {
	eval 'sub map_read {
	    my($map, $ofs) = @_;
    	    eval q( &inline_map_read($map, $ofs));
	}' unless defined(&map_read);
	eval 'sub map_copy_from {
	    my($map, $to, $from, $len) = @_;
    	    eval q( &inline_map_copy_from($map, $to, $from, $len));
	}' unless defined(&map_copy_from);
	eval 'sub map_write {
	    my($map, $datum, $ofs) = @_;
    	    eval q( &inline_map_write($map, $datum, $ofs));
	}' unless defined(&map_write);
	eval 'sub map_copy_to {
	    my($map, $to, $from, $len) = @_;
    	    eval q( &inline_map_copy_to($map, $to, $from, $len));
	}' unless defined(&map_copy_to);
	eval 'sub simple_map_init {
	    my($map) = @_;
    	    eval q( &BUG_ON(! &map_bankwidth_supported(($map)-> &bankwidth)));
	}' unless defined(&simple_map_init);
	eval 'sub map_is_linear {
	    my($map) = @_;
    	    eval q(({ ( &void)($map); 1; }));
	}' unless defined(&map_is_linear);
    }
}
1;
