require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__MTD_MTD_H__)) {
    eval 'sub __MTD_MTD_H__ () {1;}' unless defined(&__MTD_MTD_H__);
    unless(defined(&__KERNEL__)) {
	die("This\ is\ a\ kernel\ header\.\ Perhaps\ include\ mtd\-user\.h\ instead\?");
    }
    require 'linux/config.ph';
    require 'linux/types.ph';
    require 'linux/module.ph';
    require 'linux/uio.ph';
    require 'linux/notifier.ph';
    require 'linux/mtd/compatmac.ph';
    require 'mtd/mtd-abi.ph';
    eval 'sub MTD_CHAR_MAJOR () {90;}' unless defined(&MTD_CHAR_MAJOR);
    eval 'sub MTD_BLOCK_MAJOR () {31;}' unless defined(&MTD_BLOCK_MAJOR);
    eval 'sub MAX_MTD_DEVICES () {16;}' unless defined(&MAX_MTD_DEVICES);
    eval 'sub MTD_ERASE_PENDING () {0x1;}' unless defined(&MTD_ERASE_PENDING);
    eval 'sub MTD_ERASING () {0x2;}' unless defined(&MTD_ERASING);
    eval 'sub MTD_ERASE_SUSPEND () {0x4;}' unless defined(&MTD_ERASE_SUSPEND);
    eval 'sub MTD_ERASE_DONE () {0x8;}' unless defined(&MTD_ERASE_DONE);
    eval 'sub MTD_ERASE_FAILED () {0x10;}' unless defined(&MTD_ERASE_FAILED);
    eval 'sub MTD_PROGREGION_SIZE {
        my($mtd) = @_;
	    eval q(($mtd)-> &oobblock);
    }' unless defined(&MTD_PROGREGION_SIZE);
    eval 'sub MTD_PROGREGION_CTRLMODE_VALID {
        my($mtd) = @_;
	    eval q(($mtd)-> &oobsize);
    }' unless defined(&MTD_PROGREGION_CTRLMODE_VALID);
    eval 'sub MTD_PROGREGION_CTRLMODE_INVALID {
        my($mtd) = @_;
	    eval q(($mtd)-> &ecctype);
    }' unless defined(&MTD_PROGREGION_CTRLMODE_INVALID);
    eval 'sub MTD_ERASE () {( &mtd,  &args...) (*( ($mtd->{erase})))( &mtd,  &args);}' unless defined(&MTD_ERASE);
    eval 'sub MTD_POINT {
        my($mtd, $a,$b,$c,$d) = @_;
	    eval q((*( ($mtd->{point})))($mtd, $a,$b,$c, ($d)));
    }' unless defined(&MTD_POINT);
    eval 'sub MTD_UNPOINT {
        my($mtd, $arg) = @_;
	    eval q((*( ($mtd->{unpoint})))($mtd, $arg));
    }' unless defined(&MTD_UNPOINT);
    eval 'sub MTD_READ () {( &mtd,  &args...) (*( ($mtd->{read})))( &mtd,  &args);}' unless defined(&MTD_READ);
    eval 'sub MTD_WRITE () {( &mtd,  &args...) (*( ($mtd->{write})))( &mtd,  &args);}' unless defined(&MTD_WRITE);
    eval 'sub MTD_READV () {( &mtd,  &args...) (*( ($mtd->{readv})))( &mtd,  &args);}' unless defined(&MTD_READV);
    eval 'sub MTD_WRITEV () {( &mtd,  &args...) (*( ($mtd->{writev})))( &mtd,  &args);}' unless defined(&MTD_WRITEV);
    eval 'sub MTD_READECC () {( &mtd,  &args...) (*( ($mtd->{read_ecc})))( &mtd,  &args);}' unless defined(&MTD_READECC);
    eval 'sub MTD_WRITEECC () {( &mtd,  &args...) (*( ($mtd->{write_ecc})))( &mtd,  &args);}' unless defined(&MTD_WRITEECC);
    eval 'sub MTD_READOOB () {( &mtd,  &args...) (*( ($mtd->{read_oob})))( &mtd,  &args);}' unless defined(&MTD_READOOB);
    eval 'sub MTD_WRITEOOB () {( &mtd,  &args...) (*( ($mtd->{write_oob})))( &mtd,  &args);}' unless defined(&MTD_WRITEOOB);
    eval 'sub MTD_SYNC {
        my($mtd) = @_;
	    eval q( &do {  &if ( ($mtd->{sync})) (*( ($mtd->{sync})))($mtd); }  &while (0));
    }' unless defined(&MTD_SYNC);
    if(defined(&CONFIG_MTD_PARTITIONS)) {
    } else {
	eval 'sub mtd_erase_callback {
	    my($instr) = @_;
    	    eval q({  &if ( ($instr->{callback}))  ($instr->{callback})($instr); });
	}' unless defined(&mtd_erase_callback);
    }
    eval 'sub MTD_DEBUG_LEVEL0 () {(0);}' unless defined(&MTD_DEBUG_LEVEL0);
    eval 'sub MTD_DEBUG_LEVEL1 () {(1);}' unless defined(&MTD_DEBUG_LEVEL1);
    eval 'sub MTD_DEBUG_LEVEL2 () {(2);}' unless defined(&MTD_DEBUG_LEVEL2);
    eval 'sub MTD_DEBUG_LEVEL3 () {(3);}' unless defined(&MTD_DEBUG_LEVEL3);
    if(defined(&CONFIG_MTD_DEBUG)) {
	eval 'sub DEBUG () {( &n,  &args...)  &do {  &if ( &n <=  &CONFIG_MTD_DEBUG_VERBOSE)  &printk( &KERN_INFO  &args); }  &while(0);}' unless defined(&DEBUG);
    } else {
	eval 'sub DEBUG () {( &n,  &args...)  &do { }  &while(0);}' unless defined(&DEBUG);
    }
}
1;
