require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_MTD_NAND_H)) {
    eval 'sub __LINUX_MTD_NAND_H () {1;}' unless defined(&__LINUX_MTD_NAND_H);
    require 'linux/config.ph';
    require 'linux/wait.ph';
    require 'linux/spinlock.ph';
    require 'linux/mtd/mtd.ph';
    eval 'sub NAND_MAX_CHIPS () {8;}' unless defined(&NAND_MAX_CHIPS);
    eval 'sub NAND_MAX_OOBSIZE () {64;}' unless defined(&NAND_MAX_OOBSIZE);
    eval 'sub NAND_CTL_SETNCE () {1;}' unless defined(&NAND_CTL_SETNCE);
    eval 'sub NAND_CTL_CLRNCE () {2;}' unless defined(&NAND_CTL_CLRNCE);
    eval 'sub NAND_CTL_SETCLE () {3;}' unless defined(&NAND_CTL_SETCLE);
    eval 'sub NAND_CTL_CLRCLE () {4;}' unless defined(&NAND_CTL_CLRCLE);
    eval 'sub NAND_CTL_SETALE () {5;}' unless defined(&NAND_CTL_SETALE);
    eval 'sub NAND_CTL_CLRALE () {6;}' unless defined(&NAND_CTL_CLRALE);
    eval 'sub NAND_CTL_SETWP () {7;}' unless defined(&NAND_CTL_SETWP);
    eval 'sub NAND_CTL_CLRWP () {8;}' unless defined(&NAND_CTL_CLRWP);
    eval 'sub NAND_CMD_READ0 () {0;}' unless defined(&NAND_CMD_READ0);
    eval 'sub NAND_CMD_READ1 () {1;}' unless defined(&NAND_CMD_READ1);
    eval 'sub NAND_CMD_PAGEPROG () {0x10;}' unless defined(&NAND_CMD_PAGEPROG);
    eval 'sub NAND_CMD_READOOB () {0x50;}' unless defined(&NAND_CMD_READOOB);
    eval 'sub NAND_CMD_ERASE1 () {0x60;}' unless defined(&NAND_CMD_ERASE1);
    eval 'sub NAND_CMD_STATUS () {0x70;}' unless defined(&NAND_CMD_STATUS);
    eval 'sub NAND_CMD_STATUS_MULTI () {0x71;}' unless defined(&NAND_CMD_STATUS_MULTI);
    eval 'sub NAND_CMD_SEQIN () {0x80;}' unless defined(&NAND_CMD_SEQIN);
    eval 'sub NAND_CMD_READID () {0x90;}' unless defined(&NAND_CMD_READID);
    eval 'sub NAND_CMD_ERASE2 () {0xd0;}' unless defined(&NAND_CMD_ERASE2);
    eval 'sub NAND_CMD_RESET () {0xff;}' unless defined(&NAND_CMD_RESET);
    eval 'sub NAND_CMD_READSTART () {0x30;}' unless defined(&NAND_CMD_READSTART);
    eval 'sub NAND_CMD_CACHEDPROG () {0x15;}' unless defined(&NAND_CMD_CACHEDPROG);
    eval 'sub NAND_CMD_DEPLETE1 () {0x100;}' unless defined(&NAND_CMD_DEPLETE1);
    eval 'sub NAND_CMD_DEPLETE2 () {0x38;}' unless defined(&NAND_CMD_DEPLETE2);
    eval 'sub NAND_CMD_STATUS_MULTI () {0x71;}' unless defined(&NAND_CMD_STATUS_MULTI);
    eval 'sub NAND_CMD_STATUS_ERROR () {0x72;}' unless defined(&NAND_CMD_STATUS_ERROR);
    eval 'sub NAND_CMD_STATUS_ERROR0 () {0x73;}' unless defined(&NAND_CMD_STATUS_ERROR0);
    eval 'sub NAND_CMD_STATUS_ERROR1 () {0x74;}' unless defined(&NAND_CMD_STATUS_ERROR1);
    eval 'sub NAND_CMD_STATUS_ERROR2 () {0x75;}' unless defined(&NAND_CMD_STATUS_ERROR2);
    eval 'sub NAND_CMD_STATUS_ERROR3 () {0x76;}' unless defined(&NAND_CMD_STATUS_ERROR3);
    eval 'sub NAND_CMD_STATUS_RESET () {0x7f;}' unless defined(&NAND_CMD_STATUS_RESET);
    eval 'sub NAND_CMD_STATUS_CLEAR () {0xff;}' unless defined(&NAND_CMD_STATUS_CLEAR);
    eval 'sub NAND_STATUS_FAIL () {0x1;}' unless defined(&NAND_STATUS_FAIL);
    eval 'sub NAND_STATUS_FAIL_N1 () {0x2;}' unless defined(&NAND_STATUS_FAIL_N1);
    eval 'sub NAND_STATUS_TRUE_READY () {0x20;}' unless defined(&NAND_STATUS_TRUE_READY);
    eval 'sub NAND_STATUS_READY () {0x40;}' unless defined(&NAND_STATUS_READY);
    eval 'sub NAND_STATUS_WP () {0x80;}' unless defined(&NAND_STATUS_WP);
    eval 'sub NAND_ECC_NONE () {0;}' unless defined(&NAND_ECC_NONE);
    eval 'sub NAND_ECC_SOFT () {1;}' unless defined(&NAND_ECC_SOFT);
    eval 'sub NAND_ECC_HW3_256 () {2;}' unless defined(&NAND_ECC_HW3_256);
    eval 'sub NAND_ECC_HW3_512 () {3;}' unless defined(&NAND_ECC_HW3_512);
    eval 'sub NAND_ECC_HW6_512 () {4;}' unless defined(&NAND_ECC_HW6_512);
    eval 'sub NAND_ECC_HW8_512 () {6;}' unless defined(&NAND_ECC_HW8_512);
    eval 'sub NAND_ECC_HW12_2048 () {7;}' unless defined(&NAND_ECC_HW12_2048);
    eval 'sub NAND_ECC_READ () {0;}' unless defined(&NAND_ECC_READ);
    eval 'sub NAND_ECC_WRITE () {1;}' unless defined(&NAND_ECC_WRITE);
    eval 'sub NAND_ECC_READSYN () {2;}' unless defined(&NAND_ECC_READSYN);
    eval 'sub NAND_GET_DEVICE () {0x80;}' unless defined(&NAND_GET_DEVICE);
    eval 'sub NAND_NO_AUTOINCR () {0x1;}' unless defined(&NAND_NO_AUTOINCR);
    eval 'sub NAND_BUSWIDTH_16 () {0x2;}' unless defined(&NAND_BUSWIDTH_16);
    eval 'sub NAND_NO_PADDING () {0x4;}' unless defined(&NAND_NO_PADDING);
    eval 'sub NAND_CACHEPRG () {0x8;}' unless defined(&NAND_CACHEPRG);
    eval 'sub NAND_COPYBACK () {0x10;}' unless defined(&NAND_COPYBACK);
    eval 'sub NAND_IS_AND () {0x20;}' unless defined(&NAND_IS_AND);
    eval 'sub NAND_4PAGE_ARRAY () {0x40;}' unless defined(&NAND_4PAGE_ARRAY);
    eval 'sub BBT_AUTO_REFRESH () {0x80;}' unless defined(&BBT_AUTO_REFRESH);
    eval 'sub NAND_SAMSUNG_LP_OPTIONS () {( &NAND_NO_PADDING |  &NAND_CACHEPRG |  &NAND_COPYBACK);}' unless defined(&NAND_SAMSUNG_LP_OPTIONS);
    eval 'sub NAND_CANAUTOINCR {
        my($chip) = @_;
	    eval q((!( ($chip->{options}) &  &NAND_NO_AUTOINCR)));
    }' unless defined(&NAND_CANAUTOINCR);
    eval 'sub NAND_MUST_PAD {
        my($chip) = @_;
	    eval q((!( ($chip->{options}) &  &NAND_NO_PADDING)));
    }' unless defined(&NAND_MUST_PAD);
    eval 'sub NAND_HAS_CACHEPROG {
        my($chip) = @_;
	    eval q((( ($chip->{options}) &  &NAND_CACHEPRG)));
    }' unless defined(&NAND_HAS_CACHEPROG);
    eval 'sub NAND_HAS_COPYBACK {
        my($chip) = @_;
	    eval q((( ($chip->{options}) &  &NAND_COPYBACK)));
    }' unless defined(&NAND_HAS_COPYBACK);
    eval 'sub NAND_CHIPOPTIONS_MSK () {(0xffff & ~ &NAND_NO_AUTOINCR);}' unless defined(&NAND_CHIPOPTIONS_MSK);
    eval 'sub NAND_USE_FLASH_BBT () {0x10000;}' unless defined(&NAND_USE_FLASH_BBT);
    eval 'sub NAND_HWECC_SYNDROME () {0x20000;}' unless defined(&NAND_HWECC_SYNDROME);
    eval 'sub NAND_SKIP_BBTSCAN () {0x40000;}' unless defined(&NAND_SKIP_BBTSCAN);
    eval 'sub NAND_OOBBUF_ALLOC () {0x40000000;}' unless defined(&NAND_OOBBUF_ALLOC);
    eval 'sub NAND_DATABUF_ALLOC () {0x80000000;}' unless defined(&NAND_DATABUF_ALLOC);
    eval("sub FL_READY () { 0; }") unless defined(&FL_READY);
    eval("sub FL_READING () { 1; }") unless defined(&FL_READING);
    eval("sub FL_WRITING () { 2; }") unless defined(&FL_WRITING);
    eval("sub FL_ERASING () { 3; }") unless defined(&FL_ERASING);
    eval("sub FL_SYNCING () { 4; }") unless defined(&FL_SYNCING);
    eval("sub FL_CACHEDPRG () { 5; }") unless defined(&FL_CACHEDPRG);
    eval("sub FL_PM_SUSPENDED () { 6; }") unless defined(&FL_PM_SUSPENDED);
    eval 'sub NAND_MFR_TOSHIBA () {0x98;}' unless defined(&NAND_MFR_TOSHIBA);
    eval 'sub NAND_MFR_SAMSUNG () {0xec;}' unless defined(&NAND_MFR_SAMSUNG);
    eval 'sub NAND_MFR_FUJITSU () {0x4;}' unless defined(&NAND_MFR_FUJITSU);
    eval 'sub NAND_MFR_NATIONAL () {0x8f;}' unless defined(&NAND_MFR_NATIONAL);
    eval 'sub NAND_MFR_RENESAS () {0x7;}' unless defined(&NAND_MFR_RENESAS);
    eval 'sub NAND_MFR_STMICRO () {0x20;}' unless defined(&NAND_MFR_STMICRO);
    eval 'sub NAND_MFR_HYNIX () {0xad;}' unless defined(&NAND_MFR_HYNIX);
    eval 'sub NAND_BBT_NRBITS_MSK () {0xf;}' unless defined(&NAND_BBT_NRBITS_MSK);
    eval 'sub NAND_BBT_1BIT () {0x1;}' unless defined(&NAND_BBT_1BIT);
    eval 'sub NAND_BBT_2BIT () {0x2;}' unless defined(&NAND_BBT_2BIT);
    eval 'sub NAND_BBT_4BIT () {0x4;}' unless defined(&NAND_BBT_4BIT);
    eval 'sub NAND_BBT_8BIT () {0x8;}' unless defined(&NAND_BBT_8BIT);
    eval 'sub NAND_BBT_LASTBLOCK () {0x10;}' unless defined(&NAND_BBT_LASTBLOCK);
    eval 'sub NAND_BBT_ABSPAGE () {0x20;}' unless defined(&NAND_BBT_ABSPAGE);
    eval 'sub NAND_BBT_SEARCH () {0x40;}' unless defined(&NAND_BBT_SEARCH);
    eval 'sub NAND_BBT_PERCHIP () {0x80;}' unless defined(&NAND_BBT_PERCHIP);
    eval 'sub NAND_BBT_VERSION () {0x100;}' unless defined(&NAND_BBT_VERSION);
    eval 'sub NAND_BBT_CREATE () {0x200;}' unless defined(&NAND_BBT_CREATE);
    eval 'sub NAND_BBT_SCANALLPAGES () {0x400;}' unless defined(&NAND_BBT_SCANALLPAGES);
    eval 'sub NAND_BBT_SCANEMPTY () {0x800;}' unless defined(&NAND_BBT_SCANEMPTY);
    eval 'sub NAND_BBT_WRITE () {0x1000;}' unless defined(&NAND_BBT_WRITE);
    eval 'sub NAND_BBT_SAVECONTENT () {0x2000;}' unless defined(&NAND_BBT_SAVECONTENT);
    eval 'sub NAND_BBT_SCAN2NDPAGE () {0x4000;}' unless defined(&NAND_BBT_SCAN2NDPAGE);
    eval 'sub NAND_BBT_SCAN_MAXBLOCKS () {4;}' unless defined(&NAND_BBT_SCAN_MAXBLOCKS);
    eval 'sub NAND_SMALL_BADBLOCK_POS () {5;}' unless defined(&NAND_SMALL_BADBLOCK_POS);
    eval 'sub NAND_LARGE_BADBLOCK_POS () {0;}' unless defined(&NAND_LARGE_BADBLOCK_POS);
}
1;
